executeSql
Execute a SQL statement (query, DML, or DDL).See SQL Support for the complete set of supported SQL commands.
When a caller wants all the results from a large query (e.g., more than max_get_records_size records), they can make multiple calls to this endpoint using the
offsetandlimitparameters to page through the results. Normally, this will execute thestatementquery each time. To avoid re-executing the query each time and to keep the results in the same order, the caller should specify aPAGING_TABLEname to hold the results of the query between calls and specify thePAGING_TABLEon subsequent calls. When this is done, the caller should clear the paging table and any other tables in theRESULT_TABLE_LIST(both returned in the response) when they are done paging through the results.pagingTable(andRESULT_TABLE_LIST) will be empty if no paging table was created (e.g., when all the query results were returned in the first call).Parameters:request-Requestobject containing the parameters for the operation.Returns:Responseobject containing the results of the operation.Throws:GPUdbException- if an error occurs during the operation.executeSql
public ExecuteSqlResponse executeSql(String statement, long offset, long limit, String requestSchemaStr, List<ByteBuffer> data, Map<String, String> options) throws GPUdbException Execute a SQL statement (query, DML, or DDL).See SQL Support for the complete set of supported SQL commands.
When a caller wants all the results from a large query (e.g., more than max_get_records_size records), they can make multiple calls to this endpoint using the
offsetandlimitparameters to page through the results. Normally, this will execute thestatementquery each time. To avoid re-executing the query each time and to keep the results in the same order, the caller should specify aPAGING_TABLEname to hold the results of the query between calls and specify thePAGING_TABLEon subsequent calls. When this is done, the caller should clear the paging table and any other tables in theRESULT_TABLE_LIST(both returned in the response) when they are done paging through the results.pagingTable(andRESULT_TABLE_LIST) will be empty if no paging table was created (e.g., when all the query results were returned in the first call).Parameters:statement- SQL statement (query, DML, or DDL) to be executed.offset- A positive integer indicating the number of initial results to skip (this can be useful for paging through the results). The default value is 0. The minimum allowed value is 0. The maximum allowed value is MAX_INT.limit- A positive integer indicating the maximum number of results to be returned, or END_OF_SET (-9999) to indicate that the maximum number of results allowed by the server should be returned. The number of records returned will never exceed the server’s own limit, defined by the max_get_records_size parameter in the server configuration. UsehasMoreRecordsto see if more records exist in the result to be fetched, andoffsetandlimitto request subsequent pages of results. The default value is -9999.requestSchemaStr- Avro schema ofdata. The default value is ”.data- An array of binary-encoded data for the records to be binded to the SQL query. Or useQUERY_PARAMETERSto pass the data in JSON format. The default value is an emptyList.options- Optional parameters.COST_BASED_OPTIMIZATION: IfFALSE, disables the cost-based optimization of the given query. Supported values:The default value isFALSE.DISTRIBUTED_JOINS: IfTRUE, enables the use of distributed joins in servicing the given query. Any query requiring a distributed join will succeed, though hints can be used in the query to change the distribution of the source data to allow the query to succeed. Supported values:The default value isFALSE.DISTRIBUTED_OPERATIONS: IfTRUE, enables the use of distributed operations in servicing the given query. Any query requiring a distributed join will succeed, though hints can be used in the query to change the distribution of the source data to allow the query to succeed. Supported values:The default value isFALSE.IGNORE_EXISTING_PK: Specifies the record collision error-suppression policy for inserting into or updating a table with a primary key, only used when primary key record collisions are rejected (UPDATE_ON_EXISTING_PKisFALSE). If set toTRUE, any record insert/update that is rejected for resulting in a primary key collision with an existing table record will be ignored with no error generated. IfFALSE, the rejection of any insert/update for resulting in a primary key collision will cause an error to be reported. If the specified table does not have a primary key or ifUPDATE_ON_EXISTING_PKisTRUE, then this option has no effect. Supported values:TRUE: Ignore inserts/updates that result in primary key collisions with existing records.FALSE: Treat as errors any inserts/updates that result in primary key collisions with existing records.
FALSE.LATE_MATERIALIZATION: IfTRUE, Joins/Filters results will always be materialized ( saved to result tables format). Supported values:The default value isFALSE.PAGING_TABLE: When specified (orPAGING_TABLE_TTLis set), the system will create a paging table to hold the results of the query, when the output has more records than are in the response (i.e., whenhasMoreRecordsisTRUE). If the specified paging table exists, the records from the paging table are returned without re-evaluating the query. It is the caller’s responsibility to clear thepagingTableand other tables in theRESULT_TABLE_LIST(both returned in the response) when they are done with this query.PAGING_TABLE_TTL: Sets the TTL of the paging table. -1 indicates no timeout. Setting this option will cause a paging table to be generated when needed. ThepagingTableand other tables in theRESULT_TABLE_LIST(both returned in the response) will be automatically cleared after the TTL expires, if set to a positive number. However, it is still recommended that the caller clear these tables when they are done with this query.PARALLEL_EXECUTION: IfFALSE, disables the parallel step execution of the given query. Supported values:The default value isTRUE.PLAN_CACHE: IfFALSE, disables plan caching for the given query. Supported values:The default value isTRUE.PREPARE_MODE: IfTRUE, compiles a query into an execution plan and saves it in query cache. Query execution is not performed and an empty response will be returned to user. Supported values:The default value isFALSE.PRESERVE_DICT_ENCODING: IfTRUE, then columns that were dict encoded in the source table will be dict encoded in the projection table. Supported values:The default value isTRUE.QUERY_PARAMETERS: Query parameters in JSON array or arrays (for inserting multiple rows). This can be used instead ofdataandrequestSchemaStr.RESULTS_CACHING: IfFALSE, disables caching of the results of the given query. Supported values:The default value isTRUE.RULE_BASED_OPTIMIZATION: IfFALSE, disables rule-based rewrite optimizations for the given query. Supported values:The default value isTRUE.SSQ_OPTIMIZATION: IfFALSE, scalar subqueries will be translated into joins. Supported values:The default value isTRUE.TTL: Sets the TTL of the intermediate result tables used in query execution.UPDATE_ON_EXISTING_PK: Specifies the record collision policy for inserting into or updating a table with a primary key. If set toTRUE, any existing table record with primary key values that match those of a record being inserted or updated will be replaced by that record. If set toFALSE, any such primary key collision will result in the insert/update being rejected and the error handled as determined byIGNORE_EXISTING_PK. If the specified table does not have a primary key, then this option has no effect. Supported values:TRUE: Replace the collided-into record with the record inserted or updated when a new/modified record causes a primary key collision with an existing record.FALSE: Reject the insert or update when it results in a primary key collision with an existing record.
FALSE.VALIDATE_CHANGE_COLUMN: When changing a column using alter table, validate the change before applying it. IfTRUE, then validate all values. A value too large (or too long) for the new type will prevent any change. IfFALSE, then when a value is too large or long, it will be truncated. Supported values:The default value isTRUE.CURRENT_SCHEMA: Use the supplied value as the default schema when processing this SQL command.
Map.Returns:Responseobject containing the results of the operation.Throws:GPUdbException- if an error occurs during the operation.